<?php

namespace Lc\SovBundle\Model\User;


use Doctrine\Common\Collections\Collection;

interface GroupUserInterface
{
    public function getDescription(): ?string;

    public function setDescription(?string $description);

    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function getTitle(): ?string;

    public function setTitle(string $title);

    public function addUser(UserInterface $user): GroupUserInterface;

    /**
     * @return Collection|UserInterface[]
     */
    public function getUsers(): Collection;

    public function removeUser(UserInterface $user): GroupUserInterface;

    public function getMetaTitle(): ?string;

    public function setMetaTitle(?string $metaTitle);

    public function getMetaDescription(): ?string;

    public function setMetaDescription(?string $metaDescription);

    public function setOldUrls($oldUrls);

    public function getOldUrls(): ?array;

    public function getSlug(): ?string;

    public function setSlug(?string $slug);

    /**
     * @return float
     */
    public function getPosition(): float;

    /**
     * @param float $position
     * @return $this
     */
    public function setPosition(float $position);

    public function clearPosition();

    public function getStatus(): ?float;

    public function setStatus(float $status);

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}